import { AsyncIteratorLike } from "@reactive-js/ix";
import { ErrorLike, ObservableLike, ObserverLike } from "@reactive-js/rx";
import { ObservableOperatorLike } from "@reactive-js/observable";
import { SchedulerLike } from "@reactive-js/scheduler";
export interface AsyncIteratorOperatorLike<TSrcReq, TSrc, TReq, T> {
    (iter: AsyncIteratorLike<TSrcReq, TSrc>): AsyncIteratorLike<TReq, T>;
}
export declare const lift: <TReq, T, TA>(operator: ObservableOperatorLike<T, TA>) => AsyncIteratorOperatorLike<TReq, T, TReq, TA>;
export declare const liftReq: <TReq, T, TReqA>(operator: (dispatcher: (req: TReq) => void) => (ref: TReqA) => void) => AsyncIteratorOperatorLike<TReq, T, TReqA, T>;
export declare const concatAll: <TReq, T>(maxBufferSize?: number) => AsyncIteratorOperatorLike<TReq, ObservableLike<T>, TReq, T>;
export declare const distinctUntilChanged: <TReq, T>(equals?: ((a: T, b: T) => boolean) | undefined) => AsyncIteratorOperatorLike<TReq, T, TReq, T>;
export declare const endWith: <TReq, T>(value: T, ...values: T[]) => AsyncIteratorOperatorLike<TReq, T, TReq, T>;
export declare const exhaust: <TReq, T>() => AsyncIteratorOperatorLike<TReq, ObservableLike<T>, TReq, T>;
export declare const ignoreElements: <TReq, TA, TB>() => AsyncIteratorOperatorLike<TReq, TA, TReq, TB>;
export declare const keep: <TReq, T>(predicate: (data: T) => boolean) => AsyncIteratorOperatorLike<TReq, T, TReq, T>;
export declare const map: <TReq, TA, TB>(mapper: (data: TA) => TB) => AsyncIteratorOperatorLike<TReq, TA, TReq, TB>;
export declare const mergeAll: <TReq, T>(options?: {
    maxBufferSize?: number | undefined;
    maxConcurrency?: number | undefined;
} | undefined) => AsyncIteratorOperatorLike<TReq, ObservableLike<T>, TReq, T>;
export declare const observe: <TReq, T>(observer: ObserverLike<T>) => AsyncIteratorOperatorLike<TReq, T, TReq, T>;
export declare const onComplete: <TReq, T>(onComplete: (err?: ErrorLike | undefined) => void) => AsyncIteratorOperatorLike<TReq, T, TReq, T>;
export declare const onError: <TReq, T>(onError: (err: unknown) => void) => AsyncIteratorOperatorLike<TReq, T, TReq, T>;
export declare const onNext: <TReq, T>(onNext: (next: T) => void) => AsyncIteratorOperatorLike<TReq, T, TReq, T>;
export declare const repeat: <TReq, T>(predicate?: number | ((count: number) => boolean) | undefined) => AsyncIteratorOperatorLike<TReq, T, TReq, T>;
export declare const retry: <TReq, T>(predicate?: ((count: number, error: unknown) => boolean) | undefined) => AsyncIteratorOperatorLike<TReq, T, TReq, T>;
export declare const scan: <TReq, T, TAcc>(scanner: (acc: TAcc, next: T) => TAcc, initialValue: () => TAcc) => AsyncIteratorOperatorLike<TReq, T, TReq, TAcc>;
export declare const share: <TReq, T>(scheduler: SchedulerLike, replayCount?: number | undefined) => AsyncIteratorOperatorLike<TReq, T, TReq, T>;
export declare const startWith: <TReq, T>(value: T, ...values: T[]) => AsyncIteratorOperatorLike<TReq, T, TReq, T>;
export declare const subscribeOn: <TReq, T>(scheduler: SchedulerLike) => AsyncIteratorOperatorLike<TReq, T, TReq, T>;
export declare const switchAll: <TReq, T>() => AsyncIteratorOperatorLike<TReq, ObservableLike<T>, TReq, T>;
export declare const take: <TReq, T>(count: number) => AsyncIteratorOperatorLike<TReq, T, TReq, T>;
export declare const takeLast: <TReq, T>(count: number) => AsyncIteratorOperatorLike<TReq, T, TReq, T>;
export declare const takeWhile: <TReq, T>(predicate: (next: T) => boolean) => AsyncIteratorOperatorLike<TReq, T, TReq, T>;
export declare const throttle: <TReq, T>(durationSelector: (next: T) => ObservableLike<unknown>) => AsyncIteratorOperatorLike<TReq, T, TReq, T>;
export declare const throttleTime: <TReq, T>(duration: number) => AsyncIteratorOperatorLike<TReq, T, TReq, T>;
export declare const throttleFirst: <TReq, T>(durationSelector: (next: T) => ObservableLike<unknown>) => AsyncIteratorOperatorLike<TReq, T, TReq, T>;
export declare const throttleFirstTime: <TReq, T>(duration: number) => AsyncIteratorOperatorLike<TReq, T, TReq, T>;
export declare const throttleLast: <TReq, T>(durationSelector: (next: T) => ObservableLike<unknown>) => AsyncIteratorOperatorLike<TReq, T, TReq, T>;
export declare const throttleLastTime: <TReq, T>(duration: number) => AsyncIteratorOperatorLike<TReq, T, TReq, T>;
export declare const timeout: <TReq, T>(duration: number) => AsyncIteratorOperatorLike<TReq, T, TReq, T>;
export declare const withLatestFrom: <TReq, TA, TB, TC>(other: ObservableLike<TB>, selector: (a: TA, b: TB) => TC) => AsyncIteratorOperatorLike<TReq, TA, TReq, TC>;
//# sourceMappingURL=index.d.ts.map